'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Canvas = require('../util/Canvas');

var _Canvas2 = _interopRequireDefault(_Canvas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Danmuku = function (_Component) {
  _inherits(Danmuku, _Component);

  function Danmuku() {
    var _temp, _this, _ret;

    _classCallCheck(this, Danmuku);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onWindowResize = function () {
      var _this2;

      return (_this2 = _this).__onWindowResize__REACT_HOT_LOADER__.apply(_this2, arguments);
    }, _this.insertDanmuku = function () {
      var _this3;

      return (_this3 = _this).__insertDanmuku__REACT_HOT_LOADER__.apply(_this3, arguments);
    }, _this.runDanmuku = function () {
      var _this4;

      return (_this4 = _this).__runDanmuku__REACT_HOT_LOADER__.apply(_this4, arguments);
    }, _this.drawDanmuku = function () {
      var _this5;

      return (_this5 = _this).__drawDanmuku__REACT_HOT_LOADER__.apply(_this5, arguments);
    }, _this.stopDanmuku = function () {
      var _this6;

      return (_this6 = _this).__stopDanmuku__REACT_HOT_LOADER__.apply(_this6, arguments);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Danmuku.prototype.componentDidMount = function componentDidMount() {
    this.dc = new _Canvas2.default(this.canvas, this.props.duration);
    this.dc.draw();
    window.addEventListener('resize', this.onWindowResize);
  };

  Danmuku.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
    if (nextProps.currentTime !== this.props.currentTime) {
      this.runDanmuku();
      return true;
    }
    if (nextProps.playerAction !== this.props.playerAction) {
      if (nextProps.playerAction === 1) {
        this.drawDanmuku();
      } else if (nextProps.playerAction === 2) {
        this.stopDanmuku();
      }
      return true;
    }
    return false;
  };

  // componentDidUpdate() {
  //   const { danmuku, playerAction, currentTime, loading } = this.props;
  //   if (playerAction === 1 && !loading) {
  //     const data =
  //       danmuku.filter(d => (d.timePoint >= currentTime && d.timePoint < currentTime + 0.5));
  //     this.dc.addDanmuku(data);
  //     this.dc.draw();
  //   } else if (playerAction === 2 || loading) {
  //     this.dc.stop();
  //   }
  // }

  Danmuku.prototype.componentWillUnmount = function componentWillUnmount() {
    window.removeEventListener('resize', this.onWindowResize);
    this.dc.stop();
  };

  Danmuku.prototype.__onWindowResize__REACT_HOT_LOADER__ = function __onWindowResize__REACT_HOT_LOADER__() {
    this.dc.resize(this.canvas);
  };

  Danmuku.prototype.__insertDanmuku__REACT_HOT_LOADER__ = function __insertDanmuku__REACT_HOT_LOADER__(danmu) {
    this.dc.insertDanmuku(danmu);
  };

  Danmuku.prototype.__runDanmuku__REACT_HOT_LOADER__ = function __runDanmuku__REACT_HOT_LOADER__() {
    var _props = this.props,
        danmuku = _props.danmuku,
        playerAction = _props.playerAction,
        currentTime = _props.currentTime,
        loading = _props.loading;

    if (playerAction === 1 && !loading) {
      var data = danmuku.filter(function (d) {
        return Math.round(d.timePoint) === Math.round(currentTime);
      });
      this.dc.addDanmuku(data);
      this.dc.draw();
    }
  };

  Danmuku.prototype.__drawDanmuku__REACT_HOT_LOADER__ = function __drawDanmuku__REACT_HOT_LOADER__() {
    var _props2 = this.props,
        playerAction = _props2.playerAction,
        loading = _props2.loading;

    if (playerAction === 1 && !loading) {
      this.dc.draw();
    }
  };

  Danmuku.prototype.__stopDanmuku__REACT_HOT_LOADER__ = function __stopDanmuku__REACT_HOT_LOADER__() {
    this.dc.stop();
  };

  Danmuku.prototype.render = function render() {
    var _this7 = this;

    return _react2.default.createElement('canvas', {
      className: 'player-danmuku',
      ref: function ref(node) {
        return _this7.canvas = node;
      }
    });
  };

  return Danmuku;
}(_react.Component);

Danmuku.displayName = 'IcePlayerDanmuku';
Danmuku.propTypes = {
  danmuku: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    content: _react.PropTypes.string,
    date: _react.PropTypes.string,
    timePoint: _react.PropTypes.number
  })),
  playerAction: _react.PropTypes.number,
  currentTime: _react.PropTypes.number,
  loading: _react.PropTypes.bool,
  duration: _react.PropTypes.number
};
var _default = Danmuku;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Danmuku, 'Danmuku', 'src/component/Danmuku.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/Danmuku.js');
}();

;