'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Video = function (_Component) {
  _inherits(Video, _Component);

  function Video(props) {
    _classCallCheck(this, Video);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onLoadStart = function () {
      return _this.__onLoadStart__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onLoadedMetaData = function () {
      return _this.__onLoadedMetaData__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onLoadedData = function () {
      return _this.__onLoadedData__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onWaiting = function () {
      return _this.__onWaiting__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onCanPlay = function () {
      return _this.__onCanPlay__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onError = function () {
      return _this.__onError__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.getBuffered = function () {
      return _this.__getBuffered__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.getCurrentTime = function () {
      return _this.__getCurrentTime__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setCurrentTime = function () {
      return _this.__setCurrentTime__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setLoop = function () {
      return _this.__setLoop__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setMuted = function () {
      return _this.__setMuted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setVolume = function () {
      return _this.__setVolume__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.play = function () {
      return _this.__play__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.pause = function () {
      return _this.__pause__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.video = null;
    return _this;
  }

  Video.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
    return nextProps.src !== this.props.src;
  };

  Video.prototype.__onLoadStart__REACT_HOT_LOADER__ = function __onLoadStart__REACT_HOT_LOADER__() {
    this.props.handleOnLoadStart();
  };

  Video.prototype.__onLoadedMetaData__REACT_HOT_LOADER__ = function __onLoadedMetaData__REACT_HOT_LOADER__() {
    var duration = this.video.duration;
    this.props.handleOnLoadedMetadata(duration);
  };

  Video.prototype.__onLoadedData__REACT_HOT_LOADER__ = function __onLoadedData__REACT_HOT_LOADER__() {
    this.props.handleOnLoadedData();
  };

  Video.prototype.__onWaiting__REACT_HOT_LOADER__ = function __onWaiting__REACT_HOT_LOADER__() {
    this.props.handleOnWaiting();
  };

  Video.prototype.__onCanPlay__REACT_HOT_LOADER__ = function __onCanPlay__REACT_HOT_LOADER__() {
    this.props.handleOnCanPaly();
  };

  Video.prototype.__onError__REACT_HOT_LOADER__ = function __onError__REACT_HOT_LOADER__() {
    var error = this.video.error;
    this.props.handleOnError(error);
  };

  Video.prototype.__getBuffered__REACT_HOT_LOADER__ = function __getBuffered__REACT_HOT_LOADER__() {
    var buffered = this.video.buffered;

    var end = 0;
    try {
      end = buffered.end(0) || 0;
      end = parseInt(end * 1000 + 1, 10) / 1000;
    } catch (e) {
      // continue regardless of error
    }
    return end;
  };

  Video.prototype.__getCurrentTime__REACT_HOT_LOADER__ = function __getCurrentTime__REACT_HOT_LOADER__() {
    return this.video.currentTime;
  };

  Video.prototype.__setCurrentTime__REACT_HOT_LOADER__ = function __setCurrentTime__REACT_HOT_LOADER__(time) {
    this.video.currentTime = time;
  };

  Video.prototype.__setLoop__REACT_HOT_LOADER__ = function __setLoop__REACT_HOT_LOADER__(loop) {
    this.video.loop = loop;
  };

  Video.prototype.__setMuted__REACT_HOT_LOADER__ = function __setMuted__REACT_HOT_LOADER__(muted) {
    this.video.muted = muted;
  };

  Video.prototype.__setVolume__REACT_HOT_LOADER__ = function __setVolume__REACT_HOT_LOADER__(volume) {
    this.video.volume = volume;
  };

  Video.prototype.__play__REACT_HOT_LOADER__ = function __play__REACT_HOT_LOADER__() {
    this.video.play();
  };

  Video.prototype.__pause__REACT_HOT_LOADER__ = function __pause__REACT_HOT_LOADER__() {
    this.video.pause();
  };

  Video.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement('video', {
      className: 'react-video',
      src: this.props.src,
      loop: this.props.loop,
      preload: this.props.preload,
      poster: this.props.poster,
      ref: function ref(node) {
        return _this2.video = node;
      },

      onCanPlay: this.onCanPlay,
      onError: this.onError,
      onLoadStart: this.onLoadStart,
      onLoadedMetadata: this.onLoadedMetaData,
      onLoadedData: this.onLoadedData,
      onWaiting: this.onWaiting,
      onProgress: this.onProgress,
      onPlay: this.onPlay,
      onEnded: this.handleOnEnded
    });
  };

  return Video;
}(_react.Component);

Video.displayName = 'IcePlayerVideo';
Video.propTypes = {
  src: _react.PropTypes.string,
  loop: _react.PropTypes.bool,
  preload: _react.PropTypes.string,
  poster: _react.PropTypes.string,

  handleOnLoadStart: _react.PropTypes.func.isRequired,
  handleOnLoadedMetadata: _react.PropTypes.func.isRequired,
  handleOnLoadedData: _react.PropTypes.func.isRequired,
  handleOnCanPaly: _react.PropTypes.func.isRequired,
  handleOnWaiting: _react.PropTypes.func.isRequired,
  handleOnError: _react.PropTypes.func.isRequired
};
Video.defaultProps = {
  autoPlay: false,
  preload: 'auto',
  loop: false,
  volume: 0.8,
  controls: true
};
var _default = Video;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Video, 'Video', 'src/component/Video.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/Video.js');
}();

;