'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Progress = require('./Progress');

var _Progress2 = _interopRequireDefault(_Progress);

var _DanmukuInput = require('./DanmukuInput');

var _DanmukuInput2 = _interopRequireDefault(_DanmukuInput);

var _Volume = require('./Volume');

var _Volume2 = _interopRequireDefault(_Volume);

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Controller = function (_Component) {
  _inherits(Controller, _Component);

  function Controller(props) {
    _classCallCheck(this, Controller);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.handleOnPlayIcon = function () {
      return _this.__handleOnPlayIcon__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnRepeatClick = function () {
      return _this.__handleOnRepeatClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnSetting = function () {
      return _this.__handleOnSetting__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnFullScreenClick = function () {
      return _this.__handleOnFullScreenClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.computeLeftX = function () {
      return _this.__computeLeftX__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.state = {
      showConfig: false
    };
    return _this;
  }

  Controller.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return nextProps !== this.props || nextState !== this.state;
  };

  Controller.prototype.__handleOnPlayIcon__REACT_HOT_LOADER__ = function __handleOnPlayIcon__REACT_HOT_LOADER__() {
    var _props = this.props,
        playerAction = _props.playerAction,
        startControlsTimer = _props.startControlsTimer;

    startControlsTimer();
    if (playerAction === 1) {
      // 点击暂停
      this.props.handleOnPause();
    } else {
      // 点击播放
      this.props.handleOnPlay(false);
    }
  };

  Controller.prototype.__handleOnRepeatClick__REACT_HOT_LOADER__ = function __handleOnRepeatClick__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var flag = void 0;
    if (this.props.video.loop) {
      flag = false;
    } else {
      flag = true;
    }
    this.props.setLoop(flag);
  };

  Controller.prototype.__handleOnSetting__REACT_HOT_LOADER__ = function __handleOnSetting__REACT_HOT_LOADER__() {
    var showConfig = this.state.showConfig;
    var status = false;
    if (!showConfig) {
      status = true;
    }
    this.setState({
      showConfig: status
    });
  };

  Controller.prototype.__handleOnFullScreenClick__REACT_HOT_LOADER__ = function __handleOnFullScreenClick__REACT_HOT_LOADER__() {
    this.props.handleOnFullScreen();
  };

  Controller.prototype.__computeLeftX__REACT_HOT_LOADER__ = function __computeLeftX__REACT_HOT_LOADER__(X, left, width) {
    var leftX = void 0;
    if (X < left) {
      leftX = 0;
    } else if (X > left + width) {
      leftX = width;
    } else {
      leftX = X - left;
    }
    return leftX;
  };

  Controller.prototype.render = function render() {
    var _props2 = this.props,
        controls = _props2.controls,
        playerAction = _props2.playerAction,
        show = _props2.show,
        video = _props2.video;

    if (!controls) {
      return null;
    }
    var playHtml = '<use class="video-svg-play video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_play" /><use class="video-svg-pause video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_pause" />';
    var fullScreenHtml = '<use class="video-svg-fullscreen video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_fullscreen" /><use class="video-svg-fullscreen-true video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_fullscreen_true" />';
    var settingHtml = '<use class="" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_setting" />';
    var repeatHtml = '<use class="video-svg-repeat-true video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_repeat_true" /><use class="video-svg-repeat-false video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_repeat_false" />';
    var playStatus = '';
    if (playerAction === 1 || playerAction === 3) {
      playStatus = 'pause';
    } else if (playerAction === 2) {
      playStatus = 'play';
    }
    var dataConfig = this.state.showConfig ? 'show' : 'hide';
    var fullScreen = this.props.fullScreen;
    return _react2.default.createElement(
      'div',
      { className: 'video-control-main ' + (show ? '' : 'video-control-main-hidden') },
      _react2.default.createElement(_Progress2.default, {
        currentTime: this.props.video.currentTime,
        bufferedTime: this.props.video.bufferedTime,
        duration: this.props.video.duration,
        setCurrentTime: this.props.setCurrentTime
      }),
      _react2.default.createElement(
        'div',
        { className: 'video-control-bar' },
        _react2.default.createElement(
          'button',
          {
            className: 'video-control-item video-btn-play',
            'data-status': playStatus,
            'aria-label': '\u64AD\u653E/\u6682\u505C',
            onClick: this.handleOnPlayIcon
          },
          _react2.default.createElement('svg', { className: 'video-svg', version: '1.1', dangerouslySetInnerHTML: { __html: playHtml } })
        ),
        _react2.default.createElement(_DanmukuInput2.default, {
          showControls: this.props.showControls,
          hideControls: this.props.hideControls,
          sendDanmu: this.props.sendDanmu
        }),
        _react2.default.createElement(
          'div',
          { className: 'video-control-bar-right', 'data-config': dataConfig },
          _react2.default.createElement(_Volume2.default, {
            video: this.props.video,
            volume: this.props.video.volume,
            muted: this.props.video.muted,
            setVolume: this.props.setVolume,
            setMuted: this.props.setMuted
          }),
          _react2.default.createElement(
            'button',
            {
              className: 'video-control-item video-btn-setting',
              'aria-label': '\u8BBE\u7F6E',
              'data-config': dataConfig,
              onClick: this.handleOnSetting
            },
            _react2.default.createElement('svg', { className: 'video-svg', version: '1.1', dangerouslySetInnerHTML: { __html: settingHtml } })
          ),
          _react2.default.createElement(
            'button',
            {
              className: 'video-control-item video-btn-repeat',
              'aria-label': '\u5FAA\u73AF',
              'data-status': video.loop,
              'data-msg': '' + (video.loop ? '关闭循环' : '洗脑循环'),
              onClick: this.handleOnRepeatClick
            },
            _react2.default.createElement('svg', { className: 'video-svg', version: '1.1', dangerouslySetInnerHTML: { __html: repeatHtml } })
          ),
          _react2.default.createElement(
            'button',
            {
              className: 'video-control-item video-btn-fullscreen',
              'aria-label': '\u5168\u5C4F',
              'data-status': fullScreen,
              onClick: this.handleOnFullScreenClick
            },
            _react2.default.createElement('svg', { className: 'video-svg', version: '1.1', dangerouslySetInnerHTML: { __html: fullScreenHtml } })
          ),
          _react2.default.createElement(_Config2.default, {
            danmukuConfig: this.props.danmukuConfig,
            playerConfig: this.props.playerConfig,
            setDanmukuConfig: this.props.setDanmukuConfig,
            setPlayerConfig: this.props.setPlayerConfig
          })
        )
      )
    );
  };

  return Controller;
}(_react.Component);

Controller.displayName = 'IcePlayerController';
Controller.propTypes = {
  controls: _react.PropTypes.bool.isRequired,
  playerAction: _react.PropTypes.number.isRequired,
  show: _react.PropTypes.bool.isRequired,
  video: _react.PropTypes.shape({
    playTimes: _react.PropTypes.number.isRequired,
    duration: _react.PropTypes.number.isRequired,
    currentTime: _react.PropTypes.number.isRequired,
    bufferedTime: _react.PropTypes.number.isRequired,
    volume: _react.PropTypes.number.isRequired,
    muted: _react.PropTypes.bool.isRequired,
    loop: _react.PropTypes.bool.isRequired
  }),
  fullScreen: _react.PropTypes.bool,
  danmukuConfig: _react.PropTypes.shape({
    fontColor: _react.PropTypes.string,
    fontSize: _react.PropTypes.oneOf(['small', 'middle', 'large']),
    model: _react.PropTypes.oneOf(['roll', 'top', 'bottom'])
  }),
  playerConfig: _react.PropTypes.shape({
    opacity: _react.PropTypes.number,
    scale: _react.PropTypes.string,
    onOff: _react.PropTypes.bool
  }),

  handleOnPause: _react.PropTypes.func.isRequired,
  handleOnPlay: _react.PropTypes.func.isRequired,
  startControlsTimer: _react.PropTypes.func.isRequired,
  setCurrentTime: _react.PropTypes.func.isRequired,
  showControls: _react.PropTypes.func.isRequired,
  hideControls: _react.PropTypes.func.isRequired,
  setVolume: _react.PropTypes.func.isRequired,
  setMuted: _react.PropTypes.func.isRequired,
  setLoop: _react.PropTypes.func.isRequired,
  setDanmukuConfig: _react.PropTypes.func.isRequired,
  setPlayerConfig: _react.PropTypes.func.isRequired,
  sendDanmu: _react.PropTypes.func.isRequired,
  handleOnFullScreen: _react.PropTypes.func.isRequired
};
var _default = Controller;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Controller, 'Controller', 'src/component/controller/Controller.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/controller/Controller.js');
}();

;