'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FullScreen = function () {
  function FullScreen() {
    var _this = this;

    _classCallCheck(this, FullScreen);

    this.request = function () {
      return _this.__request__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.exit = function () {
      return _this.__exit__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isFullscreen = function () {
      return _this.__isFullscreen__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isEnabled = function () {
      return _this.__isEnabled__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addEventListener = function () {
      return _this.__addEventListener__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.removeEventListener = function () {
      return _this.__removeEventListener__REACT_HOT_LOADER__.apply(_this, arguments);
    };
  }

  FullScreen.prototype.__request__REACT_HOT_LOADER__ = function __request__REACT_HOT_LOADER__(elm) {
    if (elm.requestFullscreen) {
      elm.requestFullscreen();
    } else if (elm.webkitRequestFullscreen) {
      elm.webkitRequestFullscreen();
    } else if (elm.mozRequestFullScreen) {
      elm.mozRequestFullScreen();
    } else if (elm.msRequestFullscreen) {
      elm.msRequestFullscreen();
    }
  };

  FullScreen.prototype.__exit__REACT_HOT_LOADER__ = function __exit__REACT_HOT_LOADER__() {
    if (document.exitFullscreen) {
      document.exitFullscreen();
    } else if (document.webkitExitFullscreen) {
      document.webkitExitFullscreen();
    } else if (document.mozCancelFullScreen) {
      document.mozCancelFullScreen();
    } else if (document.msExitFullscreen) {
      document.msExitFullscreen();
    }
  };

  FullScreen.prototype.__isFullscreen__REACT_HOT_LOADER__ = function __isFullscreen__REACT_HOT_LOADER__() {
    return document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement;
  };

  FullScreen.prototype.__isEnabled__REACT_HOT_LOADER__ = function __isEnabled__REACT_HOT_LOADER__() {
    return document.fullscreenEnabled || document.webkitFullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled;
  };

  FullScreen.prototype.__addEventListener__REACT_HOT_LOADER__ = function __addEventListener__REACT_HOT_LOADER__(handler) {
    document.addEventListener('fullscreenchange', handler);
    document.addEventListener('webkitfullscreenchange', handler);
    document.addEventListener('mozfullscreenchange', handler);
    document.addEventListener('MSFullscreenChange', handler);
  };

  FullScreen.prototype.__removeEventListener__REACT_HOT_LOADER__ = function __removeEventListener__REACT_HOT_LOADER__(handler) {
    document.removeEventListener('fullscreenchange', handler);
    document.removeEventListener('webkitfullscreenchange', handler);
    document.removeEventListener('mozfullscreenchange', handler);
    document.removeEventListener('MSFullscreenChange', handler);
  };

  return FullScreen;
}();

var _default = new FullScreen();

exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FullScreen, 'FullScreen', 'src/util/fullScreen.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/util/fullScreen.js');
}();

;